import { ParsedTypesConfig } from '@graphql-codegen/visitor-plugin-common';
import { TypeScriptPluginConfig } from './index';
import { FieldDefinitionNode, NamedTypeNode, ListTypeNode, NonNullTypeNode, EnumTypeDefinitionNode, InputValueDefinitionNode, GraphQLSchema, ObjectTypeDefinitionNode, InterfaceTypeDefinitionNode } from 'graphql';
import { BaseTypesVisitor } from './base-types-visitor';
export interface TypeScriptPluginParsedConfig extends ParsedTypesConfig {
    avoidOptionals: boolean;
    constEnums: boolean;
    enumsAsTypes: boolean;
    immutableTypes: boolean;
    maybeValue: string;
    outputTypeGraphQL: boolean;
}
export declare class TsVisitor<TRawConfig extends TypeScriptPluginConfig = TypeScriptPluginConfig, TParsedConfig extends TypeScriptPluginParsedConfig = TypeScriptPluginParsedConfig> extends BaseTypesVisitor<TRawConfig, TParsedConfig> {
    constructor(schema: GraphQLSchema, pluginConfig: TRawConfig, additionalConfig?: Partial<TParsedConfig>);
    private clearOptional;
    NamedType(node: NamedTypeNode): string;
    ListType(node: ListTypeNode): string;
    protected wrapWithListType(str: string): string;
    NonNullType(node: NonNullTypeNode): string;
    ObjectTypeDefinition(node: ObjectTypeDefinitionNode, key: number | string, parent: any): string;
    InterfaceTypeDefinition(node: InterfaceTypeDefinitionNode, key: number | string, parent: any): string;
    parseType(typeString: string): {
        type: string;
        isNullable: boolean;
        isArray: boolean;
        isScalar: RegExpMatchArray;
    };
    FieldDefinition(node: FieldDefinitionNode, key?: number | string, parent?: any): string;
    InputValueDefinition(node: InputValueDefinitionNode, key?: number | string, parent?: any): string;
    EnumTypeDefinition(node: EnumTypeDefinitionNode): string;
}
